uk.ac.starlink.pds4

## Class Pds4TableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedTableBuilder
  - - uk.ac.starlink.pds4.Pds4TableBuilder

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, MultiTableBuilder, TableBuilder

      public class Pds4TableBuilder
      extends DocumentedTableBuilder
      implements MultiTableBuilder

  TableBuilder implementation for the NASA PDSv4 format.
  Since:
    24 Nov 2021
  See Also:
    https://pds.nasa.gov/datastandards/documents/

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Pds4TableBuilder()` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table.
    `boolean` | `canStream()` No chance of streaming a format which stores the data in a different file.
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `boolean` | `getCheckMagic()` Indicates whether handler will attempt to guess by looking at the file whether it is PDS4.
    `java.lang.String` | `getFormatName()` Returns the name of the format which can be read by this handler.
    `boolean` | `getObservationalOnly()` Indicates whether only tables within File_Area_Observational elements of the PDS4 label are interpreted as StarTables.
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `static boolean` | `isMagic(byte[] intro)` Determines whether a byte buffer contains what looks like the start of a PDS4 file.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy storage)` Constructs a `StarTable` based on a given `DataSource`.
    `TableSequence` | `makeStarTables(DataSource datsrc, StoragePolicy storage)` Constructs a sequence of StarTables based on a given DataSource.
    `void` | `setCheckMagic(boolean checkMagic)` Sets whether the handler will attempt to guess by looking at the file whether it appears to be a PDS4 file before attempting to parse it as one.
    `void` | `setObservationalOnly(boolean observationalOnly)` Sets whether only tables within File_Area_Observational elements of the PDS4 label are interpreted as StarTables.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Reads a table from an input stream and writes it a row at a time to a sink.

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedTableBuilder

      `getExtensions, looksLikeFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.TableBuilder

      `looksLikeFile`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Constructor Detail

    - #### Pds4TableBuilder

          public Pds4TableBuilder()

      Constructor.

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Description copied from interface: `TableBuilder`
      Returns the name of the format which can be read by this handler. Matching against this string may be used by callers to identify or select this handler from a list.
      Specified by:
        `getFormatName` in interface `TableBuilder`
      Returns:
        one-word description of this handler's format

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Specified by:
        `getXmlDescription` in interface `Documented`
      Returns:
        XML description of this object

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Specified by:
        `docIncludesExample` in interface `DocumentedIOHandler`
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Description copied from interface: `TableBuilder`
      Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table. It should return `true` if it thinks that its `TableBuilder.streamStarTable(java.io.InputStream, uk.ac.starlink.table.TableSink, java.lang.String)` method stands a reasonable chance of successfully constructing a `StarTable` from a `DataSource` whose input stream is described by the `DataFlavor` `flavor`. It will typically make this determination based on the flavor's MIME type.

      This method should only return `true` if the flavor looks like it is targeted at this builder; for instance a builder which uses a text-based format should return false for a flavor which indicates a MIME type of `text/plain`.

      This method is used in supporting drag and drop functionality (see `StarTableFactory.canImport(java.awt.datatransfer.DataFlavor[])`).

      Specified by:
        `canImport` in interface `TableBuilder`
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### canStream

          public boolean canStream()

      No chance of streaming a format which stores the data in a different file.
      Specified by:
        `canStream` in class `DocumentedTableBuilder`
      Returns:
        true iff this handler can read from streams

    - #### setCheckMagic

          @ConfigMethod(property="checkmagic",
                        doc="<p>Determines whether an initial test is made to see whether\nthe file looks like PDS4 before attempting to read it as one.\nThe tests are ad-hoc and look for certain elements\nand namespaces that are expected to appear near the start of\na table-containing PDS4 file, but it\'s not bulletproof.\nSetting this true is generally a good idea\nto avoid attempting to parse non-PDS4 files,\nbut you can set it false to attempt to read an PDS4 file\nthat starts with the wrong sequence.\n</p>",
                        example="false")
          public void setCheckMagic(boolean checkMagic)

      Sets whether the handler will attempt to guess by looking at the file whether it appears to be a PDS4 file before attempting to parse it as one. This is generally a good idea, since otherwise it will attempt to parse any old file as PDS4 which may consume resources (especially if it's a large XML file), but you can set it false to try to parse PDS4 files with unexpected first few bytes.
      Parameters:
        `checkMagic` - true to require magic number presence

    - #### getCheckMagic

          public boolean getCheckMagic()

      Indicates whether handler will attempt to guess by looking at the file whether it is PDS4.
      Returns:
        magic checking flag

    - #### setObservationalOnly

          @ConfigMethod(property="observational",
                        doc="<p>Determines whether only tables within a\n<code>&lt;File_Area_Observational&gt;</code> element\nof the PDS4 label should be included.\nIf true, only observational tables are found,\nif false, other tables will be found as well.\n</p>",
                        example="true")
          public void setObservationalOnly(boolean observationalOnly)

      Sets whether only tables within File_Area_Observational elements of the PDS4 label are interpreted as StarTables.
      Parameters:
        `observationalOnly` - if true, only observational tables are found, if false, others may be found as well

    - #### getObservationalOnly

          public boolean getObservationalOnly()

      Indicates whether only tables within File_Area_Observational elements of the PDS4 label are interpreted as StarTables.
      Returns:
        observational-only flag

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws TableFormatException

      Description copied from interface: `TableBuilder`
      Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

      The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

      Specified by:
        `streamStarTable` in interface `TableBuilder`
      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy storage)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Specified by:
        `makeStarTable` in interface `TableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `storage` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### makeStarTables

          public TableSequence makeStarTables(DataSource datsrc,
                                              StoragePolicy storage)
                                       throws java.io.IOException

      Description copied from interface: `MultiTableBuilder`
      Constructs a sequence of StarTables based on a given DataSource. If the source is not recognised or this object does not know how to make tables from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      If the `position` of the data source is not null, then this method should return a sequence containing a single table, the one which would be returned by the `makeStarTable` method with that position.

      Specified by:
        `makeStarTables` in interface `MultiTableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `storage` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        an array of StarTables read from `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### isMagic

          public static boolean isMagic(byte[] intro)

      Determines whether a byte buffer contains what looks like the start of a PDS4 file. Not bulletproof.
      Parameters:
        `intro` - first few bytes of file
      Returns:
        true if the intro looks like the start of a PDS4 file